<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ObservacaoDesconto {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
  
	public function buscaData($CDFILIAL, $DTINICIAL, $DTFINAL, $CDLOJA, $NRORG) {
		$params = array(
         	":CDFILIAL" => $CDFILIAL,
         	":CDLOJA" => $CDLOJA,
         	":TCDFILIAL" => "N",
         	":TCDLOJA" => (count($CDLOJA) != 0) ?  "N" : "T",
         	":DTVENDAINI" => $DTINICIAL,
         	":DTVENDAFIN" => $DTFINAL
 		);
		$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_DATA_OBS_DESCONTO, $params);
	 	
	    return $response;
	}
	
	const BUSCA_DATA_OBS_DESCONTO = "
    	   SELECT 
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO,
               V.CDGRPOCORDESC, G.DSGRPOCOR, V.DSOBSDESC, V.CDSUPERVISOR, P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA AS LABELLOJA,
               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
               SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'CUPOM' AS TIPODESC
            FROM 
               FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
            WHERE 
               ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:TCDFILIAL = 'T')) AND 
               ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) AND 
               (L.CDFILIAL      = F.CDFILIAL       ) AND 
               (V.IDSITUVENDA   = 'O'              ) AND 
               (V.DTENTRVENDA BETWEEN TO_DATE(:DTVENDAINI, 'DD/MM/YYYY') AND TO_DATE(:DTVENDAFIN, 'DD/MM/YYYY')) AND 
               (V.CDFILIAL      = L.CDFILIAL       ) AND 
               (V.CDLOJA        = L.CDLOJA         ) AND 
               (I.CDFILIAL      = V.CDFILIAL       ) AND 
               (I.CDCAIXA       = V.CDCAIXA        ) AND 
               (I.NRSEQVENDA    = V.NRSEQVENDA     ) AND 
               (I.CDPRODUTO     = P.CDPRODUTO      ) AND 
               (V.CDGRPOCORDESC = G.CDGRPOCOR      ) AND 
               (V.NRORG = L.NRORG) AND
               (V.NRORG = I.NRORG) AND
               (P.NRORG = I.NRORG) AND
               (V.CDCLIENTE     = O.CDCLIENTE   (+)) AND 
               (V.CDCONSUMIDOR  = O.CDCONSUMIDOR(+)) AND 
               (V.CDSUPERVISOR  = P1.CDOPERADOR (+)) AND 
               (V.CDOPERADOR    = P2.CDOPERADOR (+))
            GROUP BY 
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
               V.CDGRPOCORDESC, G.DSGRPOCOR, V.DSOBSDESC, V.CDSUPERVISOR, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR
            
            UNION
            
            SELECT
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO, 
               I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA AS LABELLOJA,
               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
               SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'ITEM' AS TIPODESC
            FROM
               FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
            WHERE
               ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:TCDFILIAL = 'T')) AND 
               ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) AND 
               (L.CDFILIAL        = F.CDFILIAL       ) AND 
               (V.IDSITUVENDA     = 'O'              ) AND 
               (V.DTENTRVENDA BETWEEN TO_DATE(:DTVENDAINI, 'dd/mm/YYYY') AND TO_DATE(:DTVENDAFIN, 'dd/mm/YYYY')) AND 
               (V.CDFILIAL        = L.CDFILIAL       ) AND 
               (V.CDLOJA          = L.CDLOJA         ) AND 
               (I.CDFILIAL        = V.CDFILIAL       ) AND 
               (I.CDCAIXA         = V.CDCAIXA        ) AND 
               (I.NRSEQVENDA      = V.NRSEQVENDA     ) AND 
               (I.CDPRODUTO       = P.CDPRODUTO      ) AND 
               (I.CDGRPOCORDESCIT = G.CDGRPOCOR      ) AND 
               (V.NRORG = L.NRORG) AND
               (V.NRORG = I.NRORG) AND
               (P.NRORG = I.NRORG) AND
               (V.CDCLIENTE       = O.CDCLIENTE   (+)) AND 
               (V.CDCONSUMIDOR    = O.CDCONSUMIDOR(+)) AND 
               (I.CDSUPERVDESC    = P1.CDOPERADOR (+)) AND 
               (V.CDOPERADOR      = P2.CDOPERADOR (+))
            GROUP BY
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
               I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR
            
            UNION
            
            SELECT
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD,  P.CDARVPROD || ' - ' || P.NMPRODUTO AS NMPRODUTO, 
               '', '', '', '', P1.NMOPERADOR AS NMSUPERVISOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR, F.CDFILIAL || ' - ' || F.NMFILIAL || '         - ' || '         Loja: ' || L.NMLOJA AS LABELLOJA,
               SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) + NVL(I.VRACRITVEND,0) - NVL(I.VRDESITVEND,0)) AS VRVENDA,
               SUM(NVL(I.VRDESITVEND,0)) AS VRDESC, 'OBS' AS TIPODESC
            FROM
               FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2
            WHERE
               ((INSTR(:CDFILIAL, F.CDFILIAL          ) <> 0) OR (:TCDFILIAL = 'T')) AND 
               ((INSTR(:CDLOJA  , L.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) AND 
               (L.CDFILIAL        = F.CDFILIAL       ) AND 
               (V.IDSITUVENDA     = 'O'              ) AND 
               (V.DTENTRVENDA BETWEEN TO_DATE(:DTVENDAINI, 'dd/mm/YYYY') AND TO_DATE(:DTVENDAFIN, 'dd/mm/YYYY')) AND 
               (V.CDFILIAL        = L.CDFILIAL       ) AND 
               (V.CDLOJA          = L.CDLOJA         ) AND 
               (I.CDFILIAL        = V.CDFILIAL       ) AND 
               (I.CDCAIXA         = V.CDCAIXA        ) AND 
               (I.NRSEQVENDA      = V.NRSEQVENDA     ) AND 
               (I.CDPRODUTO       = P.CDPRODUTO      ) AND
               (V.NRORG = L.NRORG) AND
               (V.NRORG = I.NRORG) AND
               (P.NRORG = I.NRORG) AND
               ((I.CDGRPOCORDESCIT IS NULL           ) AND (V.CDGRPOCORDESC IS NULL)) AND 
               (V.CDCLIENTE       = O.CDCLIENTE   (+)) AND 
               (V.CDCONSUMIDOR    = O.CDCONSUMIDOR(+)) AND 
               (I.CDSUPERVDESC    = P1.CDOPERADOR (+)) AND 
               (V.CDOPERADOR      = P2.CDOPERADOR (+)) AND
               (I.VRDESITVEND > 0                    )
            GROUP BY
               F.CDFILIAL, F.NMFILIAL, L.CDLOJA, L.NMLOJA, V.CDCAIXA, V.NRCUPOMFIS, V.NRNOTAFISCALCE, V.DTENTRVENDA, P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, 
               I.CDGRPOCORDESCIT, G.DSGRPOCOR, I.DSOBSDESCIT, I.CDSUPERVDESC, P1.NMOPERADOR, V.CDOPERADOR, P2.NMOPERADOR, V.CDCONSUMIDOR, O.NMCONSUMIDOR
            ORDER BY
               1, 3, 5, 6
    ";
}
