<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class PerfilAcessoRepository {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getAllPerfAcesso() {
    	return $this->entityManager->getConnection()->fetchAll("SELECT * FROM PERFILACESSO");
    }

    public function getOperador($operadores){
    	$operNotFind = implode(',', $operadores);
    	return $this->entityManager->getConnection()->fetchAll("SELECT * FROM OPERADOR WHERE CDOPERADOR NOT IN (".$operNotFind.")");
    }

    public function getAllOperador(){
    	return $this->entityManager->getConnection()->fetchAll("SELECT * FROM OPERADOR");
    }

    public function getMaxNrPerfilAcesso(){
	$selecMax = $this->entityManager->getConnection()->fetchAll(Utilities\Query::RETORNA_MAXNRPERFACESSO);
	if(empty($selecMax)){
		return 1;
	}
	return $selecMax;
	}

	public function deletaPerfilAcesso($nrPerfilAcesso){
		$params = array(
    		"CDPERFIL" =>$nrPerfilAcesso,
    		"NRORG" =>1
        );

     
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PERFILACESSO, $params);

    }

    public function deleteAssocietedRules($nrPerfilAcesso) {
    			
        $params = array(
    		'GROUP_ID' =>$nrPerfilAcesso,
    		'ORGANIZATION_ID' =>1
        );

       return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_REGRAS_PERFACESSO, $params);
       
    }

    public function deleteAssocietedPerfAcessParc ($nrPerfilAcesso){


    	$params = array(
    		"CDPERFIL" => $nrPerfilAcesso,
    		"NRORG" =>1
        );
       

        return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_ASSOCIETED_PERFACESSOPARC, $params);

    }

    public function salvaPerfilAcesso($nmperfilacesso, $nrorg, $idativo, $nrusergroup,
				$nrperfilacesso){
    	$params = array(
			'NMPERFILACESSO'      => $nmperfilacesso,
			'NRORG' => $nrorg,
			'IDATIVO' => $idativo,
			'NRUSERGROUP' => $nrusergroup,
			'NRPERFILACESSO'=> $nrperfilacesso
		);
    	return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_PERFILACESSO, $params);

    }

    public function alteraPerfilAcesso($nmperfilacesso, $nrorg, $nrperfilacesso){
    	$params = array(
			'NMPERFILACESSO' => $nmperfilacesso,
			'NRORG' => $nrorg,
			'NRPERFILACESSO'=> $nrperfilacesso
		);
    	return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_PERFILACESSO, $params);
    }
} 