<?php
namespace Teknisa\MAN\Utilities;

use Zeedhi\Framework\Remote\cURLRequest;
use Zeedhi\Framework\Remote\HttpInterface;

class FactoryFileServerCurl {
    public static function endsWith($haystack, $needle) {
    	$length = strlen($needle);
    	if ($length == 0) {
    		return true;
    	}
    	
    	return (substr($haystack, -$length) === $needle);
    }
    
    public static function formatUrl($url) {	
    	$pattern = '/(([\/]+)$)/';
    	$replacement = '/';
    	$aux = preg_replace($pattern, $replacement, $url);
    	if($aux) 
    		$url = $aux;
    	
    	if(FactoryFileServerCurl::endsWith($url, '/'))
    		return $url . 'index.php';
    	else 
    		return $url . '/index.php';
    }
    
    public static function removeIndexPhp($url) {
        return str_replace("index.php","", $url);
    }
    

    public static function factory($fileServerUrl) {
        $fileServerUrl = FactoryFileServerCurl::removeIndexPhp($fileServerUrl);
        $fileServerUrl = FactoryFileServerCurl::formatUrl($fileServerUrl);
        
        return new cURLRequest($fileServerUrl, HttpInterface::METHOD_POST, array(
            CURLOPT_SSL_VERIFYPEER => false
        ));
    }

}